package com.example.tf.splitandgo2;

import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.View;
import android.view.Menu;
import android.view.MenuItem;
import android.text.Editable;
import android.text.TextWatcher;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.TextView.BufferType;

public class MainActivity extends AppCompatActivity implements View.OnClickListener {
    EditText etTotal, etUnit;
    TextView tvChangeValue;
    TextView tvTotalCurrency, tvUnitCurrency,tvChangeCurrency;
    EditText[] etGroupNum = new EditText[4];
    CheckBox[] cbGroup = new CheckBox[4];
    EditText[] etGroupPayment = new EditText[4];

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);

        setupWidgets();
        setPreferenceValues();
        setupListeners();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        int id = item.getItemId();

        if (id == R.id.action_preferences) {
            Intent intent = new Intent(MainActivity.this, PreferencesActivity.class);
            startActivityForResult(intent, 0);
        }

        return super.onOptionsItemSelected(item);
    }

    private void setupWidgets() {
        etTotal = (EditText)findViewById(R.id.etTotal);
        etUnit = (EditText)findViewById(R.id.etUnit);

        tvTotalCurrency = (TextView)findViewById(R.id.tvTotalCurrency);
        tvUnitCurrency = (TextView)findViewById(R.id.tvUnitCurrency);
        tvChangeCurrency = (TextView)findViewById(R.id.tvChangeCurrency);

        etGroupNum[0] = (EditText)findViewById(R.id.etGroup1num);
        etGroupNum[1] = (EditText)findViewById(R.id.etGroup2num);
        etGroupNum[2] = (EditText)findViewById(R.id.etGroup3num);
        etGroupNum[3] = (EditText)findViewById(R.id.etGroup4num);

        cbGroup[0] = (CheckBox)findViewById(R.id.cbGroup1);
        cbGroup[1] = (CheckBox)findViewById(R.id.cbGroup2);
        cbGroup[2] = (CheckBox)findViewById(R.id.cbGroup3);
        cbGroup[3] = (CheckBox)findViewById(R.id.cbGroup4);

        etGroupPayment[0] = (EditText)findViewById(R.id.etGroup1Payment);
        etGroupPayment[1] = (EditText)findViewById(R.id.etGroup2Payment);
        etGroupPayment[2] = (EditText)findViewById(R.id.etGroup3Payment);
        etGroupPayment[3] = (EditText)findViewById(R.id.etGroup4Payment);

        tvChangeValue = (TextView)findViewById(R.id.tvChangeValue);
    }

    private void setupListeners() {
        etTotal.addTextChangedListener(watchHandler);
        etUnit.addTextChangedListener(watchHandler);

        for (int i = 0; i < 4; i++) {
            etGroupNum[i].addTextChangedListener(watchHandler);
        }

        for (int i = 0; i < 4; i++) {
            etGroupPayment[i].addTextChangedListener(watchHandler);
        }

        findViewById(R.id.btnGroup1Up).setOnClickListener(this);
        findViewById(R.id.btnGroup1Down).setOnClickListener(this);
        findViewById(R.id.btnGroup2Up).setOnClickListener(this);
        findViewById(R.id.btnGroup2Down).setOnClickListener(this);
        findViewById(R.id.btnGroup3Up).setOnClickListener(this);
        findViewById(R.id.btnGroup3Down).setOnClickListener(this);
        findViewById(R.id.btnGroup4Up).setOnClickListener(this);
        findViewById(R.id.btnGroup4Down).setOnClickListener(this);
    }

    private TextWatcher watchHandler = new TextWatcher() {
        @Override
        public void beforeTextChanged(CharSequence s, int start, int count, int after) {}

        @Override
        public void onTextChanged(CharSequence s, int start, int before, int count) {}

        @Override
        public void afterTextChanged(Editable s) {
            calculatePayment();
        }
    };

    private void calculatePayment() {
        String str_total = etTotal.getText().toString();
        String str_unit = etUnit.getText().toString();
        if (str_total.length() == 0 || str_unit.length() == 0) return;

        int total = Integer.parseInt(str_total);
        int unit = Integer.parseInt(str_unit);

        int person_num = 0;
        int fixed_payment = 0;

        for (int i = 0; i < 4; i++) {
            String str_num = etGroupNum[i].getText().toString();
            String str_payment = etGroupPayment[i].getText().toString();

            int tmp_num = 0;
            int tmp_payment = 0;

            if (str_num.length() == 0) {
                tmp_num = 0;
            } else {
                tmp_num = Integer.parseInt(str_num);
            }

            if (str_payment.length() == 0) {
                tmp_payment = 0;
            } else {
                tmp_payment = Integer.parseInt(str_payment);
            }

            if (cbGroup[i].isChecked()) {
                fixed_payment += tmp_payment * tmp_num;
            } else {
                person_num += tmp_num;
            }
        }

        int to_be_devided = total - fixed_payment;
        int payment_per_person = 0;
        if (person_num == 0) {
            payment_per_person = 0;
        } else {
            payment_per_person = to_be_devided / person_num;
            if (to_be_devided % person_num != 0) {
                payment_per_person = payment_per_person + 1;
            }
            if (payment_per_person % unit != 0) {
                payment_per_person = (payment_per_person / unit) * unit + unit;
            }
        }

        for (int i = 0; i < 4; i++) {
            String str_num = etGroupNum[i].getText().toString();
            if (str_num.length() == 0) continue;

            if (cbGroup[i].isChecked()) {
                continue;
            } else {
                etGroupPayment[i].removeTextChangedListener(watchHandler);
                etGroupPayment[i].setText(String.valueOf(payment_per_person), BufferType.NORMAL);
                etGroupPayment[i].addTextChangedListener(watchHandler);
            }
        }
        int change = payment_per_person * person_num - to_be_devided;

        tvChangeValue.setText(String.valueOf(change), BufferType.NORMAL);
    }

    @Override
    public void onClick(View v) {
        int id = -1;

        String str_unit = etUnit.getText().toString();
        if (str_unit.length() == 0) return;
        int diff = Integer.parseInt(str_unit);

        if (v != null) {
            switch (v.getId()) {
                case R.id.btnGroup1Up:
                    id = 0;
                    break;
                case R.id.btnGroup1Down:
                    id = 0;
                    diff = diff * -1;
                    break;
                case R.id.btnGroup2Up:
                    id = 1;
                    break;
                case R.id.btnGroup2Down:
                    id = 1;
                    diff = diff * -1;
                    break;
                case R.id.btnGroup3Up:
                    id = 2;
                    break;
                case R.id.btnGroup3Down:
                    id = 2;
                    diff = diff * -1;
                    break;
                case R.id.btnGroup4Up:
                    id = 3;
                    break;
                case R.id.btnGroup4Down:
                    id = 3;
                    diff = diff * -1;
                    break;
                default:
                    break;
            }

            if (id < 0) return;

            String str_num = etGroupNum[id].getText().toString();
            if (str_num.length() == 0) return;

            int group_payment = 0;
            String group_payment_str = etGroupPayment[id].getText().toString();
            if (group_payment_str.length() > 0) {
                group_payment = Integer.parseInt(group_payment_str);
            }
            group_payment = group_payment + diff;

            if (group_payment < 0) return;

            cbGroup[id].setChecked(true);
            etGroupPayment[id].setText(String.valueOf(group_payment), BufferType.NORMAL);
        }
    }

    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        switch (requestCode) {
            case 0:
                setPreferenceValues();
                break;
        }
    }

    protected void setPreferenceValues() {
        SharedPreferences spf = PreferenceManager.getDefaultSharedPreferences(this);
        String str_currency = spf.getString("currency", "");
        tvTotalCurrency.setText(str_currency);
        tvUnitCurrency.setText(str_currency);
        tvChangeCurrency.setText(str_currency);

        String str_unit = spf.getString("unit", "");
        etUnit.setText(str_unit);

        String str_number_people = spf.getString("number_people", "");
        etGroupNum[0].setText(str_number_people);
    }
}
